Index: /trunk/src/cf_debug.c
===================================================================
--- /trunk/src/cf_debug.c	(revision 150)
+++ /trunk/src/cf_debug.c	(revision 151)
@@ -28,9 +28,7 @@
 		return CF_ERROR_DEBUG_INVALID_CTX
 
-/** 디버그 컨텍스트 (Opaque) */
-typedef void *	CF_Debug_Ctx;
-
 /** 콜스택 인터페이스 */
-typedef struct cf_debug_callStack {
+typedef struct cf_debug_callStack
+{
 	char	file[NAME_LENGTH + 1];		/* *< 파일 이름 */
 	char	function[NAME_LENGTH + 1];	/* *< 함수 이름 */
@@ -50,14 +48,14 @@
 } CF_DEBUG_CALLSTACK;
 
-/** 디버그 컨텍스트 (CF_Debug_Ctx의 구현) */
+/** 디버그 컨텍스트 (cf_ctx의 구현) */
 typedef struct __cf_debug_ctx__
 {
-	int				fd;
-	CF_Mutex_Ctx	mutex;
+	int		fd;
+	cf_ctx	mutex;
 
 	CF_DEBUG_CALLSTACK	callstack;
-} CF_DEBUG_CTX;
-
-static CF_Debug_Ctx	gDebugSingleCtx = NULL;
+} CF_DEBUG_CONTEXT;
+
+static cf_ctx	gDebugSingleCtx = NULL;
 
 static int
@@ -187,15 +185,15 @@
  */
 static int
-CF_Debug_CallStackPush (CF_Debug_Ctx	ctx,
-						const char		* file,
-						const char		* func,
-						const int		line)
-{
-	CF_DEBUG_CTX		* context = (CF_DEBUG_CTX *) ctx;
+CF_Debug_CallStackPush (cf_ctx		ctx,
+						const char	* file,
+						const char	* func,
+						const int	line)
+{
+	CF_DEBUG_CONTEXT	* context = (CF_DEBUG_CONTEXT *) ctx;
 	CF_DEBUG_CALLSTACK	* push = NULL;
 
 	ASSERT_CTX (ctx);
 
-	push = (CF_DEBUG_CALLSTACK *) calloc (sizeof (CF_DEBUG_CALLSTACK), 1);
+	push = NEWCTX (CF_DEBUG_CALLSTACK);
 	if (push == NULL)
 		return CF_ERROR_DEBUG_PUSH_CALLSTACK;
@@ -223,8 +221,8 @@
  */
 static int
-CF_Debug_CallStackPeek (CF_Debug_Ctx		ctx,
+CF_Debug_CallStackPeek (cf_ctx				ctx,
 						CF_Debug_CallStack	* callstack)
 {
-	CF_DEBUG_CTX		* context = (CF_DEBUG_CTX *) ctx;
+	CF_DEBUG_CONTEXT	* context = (CF_DEBUG_CONTEXT *) ctx;
 	CF_DEBUG_CALLSTACK	* pop = NULL;
 
@@ -254,8 +252,8 @@
  */
 static int
-CF_Debug_CallStackPop (CF_Debug_Ctx			ctx,
+CF_Debug_CallStackPop (cf_ctx				ctx,
 					   CF_Debug_CallStack	* callstack)
 {
-	CF_DEBUG_CTX		* context = (CF_DEBUG_CTX *) ctx;
+	CF_DEBUG_CONTEXT	* context = (CF_DEBUG_CONTEXT *) ctx;
 	CF_DEBUG_CALLSTACK	* pop = NULL;
 
@@ -283,7 +281,7 @@
  */
 static int
-CF_Debug_DestroyCtx (CF_Debug_Ctx ctx)
-{
-	CF_DEBUG_CTX * context = (CF_DEBUG_CTX *) ctx;
+CF_Debug_Destroy (cf_ctx ctx)
+{
+	CF_DEBUG_CONTEXT * context = (CF_DEBUG_CONTEXT *) ctx;
 
 	ASSERT_CTX (ctx);
@@ -293,5 +291,5 @@
 
 	if (context->mutex)
-		CF_Mutex_DestoryCtx (context->mutex);
+		CF_Mutex_Destory (context->mutex);
 
 	free (context);
@@ -303,17 +301,18 @@
  * 디버그 컨텍스트를 생성
  *
- * \return 성공 시, CF_Debug_Ctx 형태의 컨텍스트; 실패 시, NULL
+ * \return 성공 시, cf_ctx 형태의 컨텍스트; 실패 시, NULL
  *
  * \param ctx 디버그 컨텍스트
  */
 static int
-CF_Debug_CreateCtx (CF_Debug_Ctx * ctx)
-{
-	int				result = 0;
-	CF_DEBUG_CTX	* context = NULL;
+CF_Debug_Create (cf_ctx * ctx)
+{
+	int result = 0;
+
+	CF_DEBUG_CONTEXT * context = NULL;
 
 	TRY
 	{
-		context = (CF_DEBUG_CTX *) calloc (sizeof (CF_DEBUG_CTX), 1);
+		context = NEWCTX (CF_DEBUG_CONTEXT);
 		if (context == NULL)
 		{
@@ -322,5 +321,5 @@
 		}
 
-		result = CF_Mutex_CreateCtx (&context->mutex);
+		result = CF_Mutex_Create (&context->mutex);
 		if (result < 0)
 		{
@@ -328,9 +327,9 @@
 		}
 
-		*ctx = (CF_Debug_Ctx) context;
+		*ctx = (cf_ctx) context;
 	}
 	CATCH_IF (result < 0)
 	{
-		CF_Debug_DestroyCtx (context);
+		CF_Debug_Destroy (context);
 	}
 
@@ -349,5 +348,5 @@
 
 	if (gDebugSingleCtx == NULL)
-		result = CF_Debug_CreateCtx (&gDebugSingleCtx);
+		result = CF_Debug_Create (&gDebugSingleCtx);
 
 	return result;
@@ -362,9 +361,9 @@
 CF_Debug_Finalize (void)
 {
-	CF_Debug_Ctx ctx = gDebugSingleCtx;
+	cf_ctx ctx = gDebugSingleCtx;
 
 	gDebugSingleCtx = NULL;
 
-	return CF_Debug_DestroyCtx (ctx);
+	return CF_Debug_Destroy (ctx);
 }
 
@@ -383,5 +382,5 @@
 						const int	line)
 {
-	CF_DEBUG_CTX * ctx = (CF_DEBUG_CTX *)gDebugSingleCtx;
+	CF_DEBUG_CONTEXT * ctx = (CF_DEBUG_CONTEXT *)gDebugSingleCtx;
 
 	ASSERT_CTX (ctx);
@@ -402,5 +401,5 @@
 CF_Debug_LeaveFunction (void)
 {
-	CF_DEBUG_CTX * ctx = (CF_DEBUG_CTX *)gDebugSingleCtx;
+	CF_DEBUG_CONTEXT * ctx = (CF_DEBUG_CONTEXT *)gDebugSingleCtx;
 
 	ASSERT_CTX (ctx);
@@ -425,5 +424,5 @@
 	int iter = 0;
 
-	CF_DEBUG_CTX		* ctx = gDebugSingleCtx;
+	CF_DEBUG_CONTEXT	* ctx = gDebugSingleCtx;
 	CF_DEBUG_CALLSTACK	* callstack = NULL;
 
Index: /trunk/src/cf_file.c
===================================================================
--- /trunk/src/cf_file.c	(revision 150)
+++ /trunk/src/cf_file.c	(revision 151)
@@ -11,4 +11,5 @@
 
 #include <stdio.h>
+#include <string.h>
 #include <fcntl.h>
 #include <errno.h>
@@ -51,7 +52,18 @@
 #define FILE_MODE		S_IWUSR|S_IRUSR|S_IRGRP|S_IROTH
 
+#define ASSERT_CTX(__ctx)	\
+	if (__ctx == NULL)		\
+		return CF_ERROR_FILE_INVALID_CTX
+
 #define ASSERT_ARGS(x)	\
 	if ((x))			\
 		return CF_ERROR_FILE_INVALID_ARGS
+
+typedef struct __cf_file_ctx__
+{
+	int				fd;
+	char			path[1024];
+	CF_FILE_FLAG	flag;
+} CF_FILE_CONTEXT;
 
 static int
@@ -73,6 +85,7 @@
  * 파일 열기
  *
- * \return 성공 시, 파일 디스크립터; 실패 시, 오류 코드
- *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx	파일 컨텍스트
  * \param path	파일 경로
  * \param flag	파일 열기 플래그
@@ -81,17 +94,44 @@
  */
 int
-CF_File_Open (const char			* path,
+CF_File_Open (cf_ctx				* ctx,
+			  const char			* path,
 			  const CF_FILE_FLAG	flag)
 {
+	int fd = 0;
 	int result = 0;
 	int osflag = 0;
 
+	CF_FILE_CONTEXT * context = NULL;
+
+	ASSERT_CTX (ctx);
 	ASSERT_ARGS (path == NULL);
 
-	osflag = CF_File_Local_ConvertFlag (flag) | O_BINARY;
-
-	result = open (path, osflag, FILE_MODE);
-	if (result < 0)
-		return CF_ERROR_FILE_OPEN;
+	TRY
+	{
+		context = NEWCTX (CF_FILE_CONTEXT);
+		if (context == NULL)
+		{
+			result = CF_ERROR_FILE_CREATE_CTX;
+			TRY_BREAK;
+		}
+		context->flag = flag;
+		context->fd = -1;
+
+		osflag = CF_File_Local_ConvertFlag (flag) | O_BINARY;
+
+		fd = open (path, osflag, FILE_MODE);
+		if (fd < 0)
+		{
+			result = CF_ERROR_FILE_OPEN;
+			TRY_BREAK;
+		}
+		context->fd = fd;
+
+		*ctx = context;
+	}
+	CATCH_IF (result < 0)
+	{
+		CF_File_Close ((cf_ctx) context);
+	}
 
 	return result;
@@ -99,38 +139,24 @@
 
 /**
- * 파일 생성
- *
- * \return 성공 시, 파일 디스크립터; 실패 시, 오류 코드
- *
- * \param path 파일 경로
- */
-int
-CF_File_Create (const char * path)
-{
-	int			result = 0;
-	const int	flag = CF_FILE_CREATE|CF_FILE_WRITE|CF_FILE_TRUNC;
-	
-	ASSERT_ARGS (path == NULL);
-
-	result = CF_File_Open (path, flag);
-	if (result < 0)
-		return CF_ERROR_FILE_CREATE;
-
-	return result;
-}
-
-/**
  * 파일 닫기
  *
  * \return 성공 시, CF_OK; 실패 시, 오류 코드
  *
- * \param fd 파일 디스크립터
- */
-int
-CF_File_Close (const int fd)
-{
-	int result = 0;
-
-	ASSERT_ARGS (fd < 0);
+ * \param ctx	파일 컨텍스트
+ */
+int
+CF_File_Close (cf_ctx ctx)
+{
+	int result = 0;
+	int fd = 0;
+
+	CF_FILE_CONTEXT * context = (CF_FILE_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+	ASSERT_ARGS (context->fd < 0);
+
+	fd = context->fd;
+
+	free (context);
 
 	result = close (fd);
@@ -146,19 +172,22 @@
  * \return 성공 시, 읽은 바이트 수; 실패 시, 오류 코드
  *
- * \param fd	파일 디스크립터
+ * \param ctx	파일 컨텍스트
  * \param buf	데이터를 저장할 메모리
  * \param len	데이터를 저장할 메모리의 크기
  */
 int
-CF_File_Read (const int		fd,
+CF_File_Read (const cf_ctx	ctx,
 			  void			* buf,
 			  const size_t	len)
 {
 	int result = 0;
-	
-	ASSERT_ARGS (fd < 0);
+
+	CF_FILE_CONTEXT * context = (CF_FILE_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+	ASSERT_ARGS (context->fd < 0);
 	ASSERT_ARGS (buf == NULL);
 
-	result = (int) read (fd, buf, len);
+	result = (int) read (context->fd, buf, len);
 	if (result < 0)
 		return CF_ERROR_FILE_READ;
@@ -172,19 +201,22 @@
  * \return 성공 시, CF_OK; 실패 시, 오류 코드
  *
- * \param fd	파일 디스크립터
+ * \param ctx	파일 컨텍스트
  * \param buf	데이터가 저장된 메모리
  * \param len	쓸 데이터의 길이
  */
 int
-CF_File_Write (const int	fd,
+CF_File_Write (const cf_ctx	ctx,
 			   const void	* buf, 
 			   const size_t	len)
 {
 	int result = 0;
-	
-	ASSERT_ARGS (fd < 0);
+
+	CF_FILE_CONTEXT * context = (CF_FILE_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+	ASSERT_ARGS (context->fd < 0);
 	ASSERT_ARGS (buf == NULL);
 
-	result = (int) write (fd, buf, len);
+	result = (int) write (context->fd, buf, len);
 	if (result != len)
 	  return CF_ERROR_FILE_WRITE;
@@ -206,7 +238,9 @@
 	int fd = 0;
 
+	CF_FILE_CONTEXT * context = NULL;
+
 	ASSERT_ARGS (path == NULL);
 
-	fd = CF_File_Open (path, CF_FILE_READ);
+	fd = CF_File_Open ((cf_ctx *)&context, path, CF_FILE_READ);
 	if (fd < 0)
 		return CF_ERROR_FILE_OPEN;
@@ -216,5 +250,5 @@
 		return CF_ERROR_FILE_GET_SIZE;
 
-	CF_File_Close (fd);
+	CF_File_Close ((cf_ctx)context);
 
 	return length;
@@ -245,13 +279,22 @@
 {
 	int		result = 0;
-	char	fullPath[1024] = {0x00,};
+	size_t	length = 0;
+	char	* fullpath = NULL;
 	char	stepPath[256] = {0x00,};
 
-	char	* f = fullPath;
-	char	* d = stepPath;
+	char	* f = NULL;
+	char	* d = NULL;
 
 	ASSERT_ARGS (path == NULL);
 
-	snprintf (fullPath, sizeof (fullPath) - 1, "%s%c", path, DELIMITER);
+	length = strlen (path);
+	fullpath = (char *) calloc (length + 2, 1);
+	if (!fullpath)
+		return CF_ERROR_FILE_ALLOCATE_BUFFER;
+
+	f = fullpath;
+	d = stepPath;
+
+	snprintf (fullpath, length + 1, "%s%c", path, DELIMITER);
 
 	for (*d++ = *f++ ; *f ; *d++ = *f++)
@@ -270,2 +313,24 @@
 	return CF_OK;
 }
+
+/**
+ * 컨텍스트가 열고 있는 파일의 경로를 가져옴
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx	파일 컨텍스트
+ * \param path	파일 경로를 저장할 충분한 공간의 메모리
+ */
+int
+CF_File_GetPath (const cf_ctx	ctx,
+				 char			* path)
+{
+	CF_FILE_CONTEXT * context = (CF_FILE_CONTEXT *) ctx;
+
+	ASSERT_CTX (context);
+	ASSERT_ARGS (path == NULL);
+
+	snprintf (path, sizeof (context->path), "%s", context->path);
+
+	return CF_OK;
+}
Index: /trunk/src/cf_list.c
===================================================================
--- /trunk/src/cf_list.c	(revision 150)
+++ /trunk/src/cf_list.c	(revision 151)
@@ -24,5 +24,5 @@
 		return CF_ERROR_DS_INVALID_ARGS
 
-/** 리스트 노드 (CF_Traverser의 구현) */
+/** 리스트 노드 (cf_traverser의 구현) */
 typedef struct __cf_node__
 {
@@ -32,5 +32,5 @@
 } CF_NODE;
 
-/** 리스트 컨텍스트 (CF_List_Ctx의 구현) */
+/** 리스트 컨텍스트 (cf_ctx의 구현) */
 typedef struct __cf_list__
 {
@@ -48,15 +48,15 @@
  */
 int
-CF_List_CreateCtx (CF_List_Ctx * ctx)
+CF_List_Create (cf_ctx * ctx)
 {
 	CF_LIST_CONTEXT * context = NULL;
 
-	ASSERT_ARGS (ctx == NULL);
-
-	context = (CF_LIST_CONTEXT *) calloc (sizeof (CF_LIST_CONTEXT), 1);
+	ASSERT_CTX (ctx);
+
+	context = NEWCTX (CF_LIST_CONTEXT);
 	if (context == NULL)
 		return CF_ERROR_DS_CREATE_CTX;
 
-	*ctx = (CF_List_Ctx) context;
+	*ctx = (cf_ctx) context;
 
 	return CF_OK;
@@ -71,5 +71,5 @@
  */
 int
-CF_List_DestroyCtx (CF_List_Ctx ctx)
+CF_List_Destroy (cf_ctx ctx)
 {
 	CF_LIST_CONTEXT * context = (CF_LIST_CONTEXT *) ctx;
@@ -85,5 +85,5 @@
 
 /**
- * 리스트 탐색자(Traverser)를 Front 위치로 설정
+ * 리스트 탐색자(traverser)를 Front 위치로 설정
  *
  * \return 성공 시, CF_OK; 실패 시, 오류 코드
@@ -93,6 +93,6 @@
  */
 int
-CF_List_Front (CF_List_Ctx	ctx,
-			   CF_Traverser	* traverser)
+CF_List_Front (cf_ctx		ctx,
+			   cf_traverser	* traverser)
 {
 	CF_LIST_CONTEXT * context = (CF_LIST_CONTEXT *) ctx;
@@ -101,11 +101,11 @@
 	ASSERT_TRAVERSER (traverser);
 
-	*traverser = (CF_Traverser *) context->front;
-
-	return CF_OK;
-}
-
-/**
- * 리스트 탐색자(Traverser)를 Rear 위치로 설정
+	*traverser = (cf_traverser *) context->front;
+
+	return CF_OK;
+}
+
+/**
+ * 리스트 탐색자(traverser)를 Rear 위치로 설정
  *
  * \return 성공 시, CF_OK; 실패 시, 오류 코드
@@ -115,6 +115,6 @@
  */
 int
-CF_List_Rear (CF_List_Ctx	ctx,
-			  CF_Traverser	* traverser)
+CF_List_Rear (cf_ctx		ctx,
+			  cf_traverser	* traverser)
 {
 	CF_LIST_CONTEXT * context = (CF_LIST_CONTEXT *) ctx;
@@ -123,11 +123,59 @@
 	ASSERT_TRAVERSER (traverser);
 
-	*traverser = (CF_Traverser *) context->rear;
-
-	return CF_OK;
-}
-
-/**
- * 리스트에 새 데이터 삽입
+	*traverser = (cf_traverser *) context->rear;
+
+	return CF_OK;
+}
+
+/**
+ * 리스트 처음에 새 데이터 삽입
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx		리스트 컨텍스트
+ * \param element	삽입할 데이터 주소
+ */
+int
+CF_List_AddFront (cf_ctx		ctx,
+				  const void	* element)
+{
+	int				result = 0;
+	cf_traverser	trav = NULL;
+
+	ASSERT_CTX (ctx);
+
+	result = CF_List_Front (ctx, &trav);
+	if (result < 0)
+		return result;
+
+	return CF_List_InsertBefore (ctx, trav, element);
+}
+
+/**
+ * 리스트 끝에 새 데이터 삽입
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx		리스트 컨텍스트
+ * \param element	삽입할 데이터 주소
+ */
+int
+CF_List_AddRear (cf_ctx		ctx,
+				 const void	* element)
+{
+	int				result = 0;
+	cf_traverser	trav = NULL;
+
+	ASSERT_CTX (ctx);
+
+	result = CF_List_Rear (ctx, &trav);
+	if (result < 0)
+		return result;
+
+	return CF_List_InsertAfter (ctx, trav, element);
+}
+
+/**
+ * 리스트 탐색자(traverser)의 앞에 새 데이터 삽입
  *
  * \return 성공 시, CF_OK; 실패 시, 오류 코드
@@ -135,25 +183,18 @@
  * \param ctx		리스트 컨텍스트
  * \param traverser	리스트 탐색자
- * \param direction	탐색자의 전/후를 지정
  * \param element	삽입할 데이터 주소
- *
- * \remarks
- * traverser가 NULL일 때,
- * direction이 CF_DIRECTION_BEFORE라면 Front 위치이고
- * direction이 CF_DIRECTION_AFTER라면 Rear 위치에 삽입
- */
-int
-CF_List_Insert (CF_List_Ctx			ctx,
-				const CF_Traverser	traverser,
-				const CF_DIRECTION	direction,
-				const void			* element)
+ */
+int
+CF_List_InsertBefore (cf_ctx				ctx,
+					  const cf_traverser	traverser,
+					  const void			* element)
 {
 	CF_LIST_CONTEXT	* context = (CF_LIST_CONTEXT *) ctx;
-	CF_NODE		* node = NULL;
-	CF_NODE		* newnode = NULL;
-
-	ASSERT_CTX (ctx);
-
-	newnode = (CF_NODE *) calloc (sizeof (CF_NODE), 1);
+	CF_NODE			* node = NULL;
+	CF_NODE			* newnode = NULL;
+
+	ASSERT_CTX (ctx);
+
+	newnode = NEWCTX (CF_NODE);
 	if (newnode == NULL)
 		return CF_ERROR_DS_CREATE_NODE;
@@ -169,36 +210,71 @@
 		}
 
-		if (direction == CF_DIRECTION_BEFORE)
+		node = traverser ? (CF_NODE *) traverser : context->front;
+
+		newnode->next = node;
+		if (node)
 		{
-			node = traverser ? (CF_NODE *) traverser : context->front;
-
-			newnode->next = node;
-			if (node)
-			{
-				newnode->prev = node->prev;
-				node->prev  = newnode;
-				if (newnode->prev)
-					newnode->prev->next = newnode;
-			}
-
-			if (node == context->front)
-				context->front = newnode;
+			newnode->prev = node->prev;
+			node->prev  = newnode;
+			if (newnode->prev)
+				newnode->prev->next = newnode;
 		}
-		else /* if (direction == CF_DIRECTION_AFTER) */
+
+		if (node == context->front)
+			context->front = newnode;
+	} NO_CATCH;
+
+	context->size++;
+
+	return CF_OK;
+}
+
+/**
+ * 리스트 탐색자(traverser)의 뒤에 새 데이터 삽입
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param ctx		리스트 컨텍스트
+ * \param traverser	리스트 탐색자
+ * \param element	삽입할 데이터 주소
+ */
+int
+CF_List_InsertAfter (cf_ctx				ctx,
+					 const cf_traverser	traverser,
+					 const void			* element)
+{
+	CF_LIST_CONTEXT	* context = (CF_LIST_CONTEXT *) ctx;
+	CF_NODE			* node = NULL;
+	CF_NODE			* newnode = NULL;
+
+	ASSERT_CTX (ctx);
+
+	newnode = NEWCTX (CF_NODE);
+	if (newnode == NULL)
+		return CF_ERROR_DS_CREATE_NODE;
+
+	newnode->element = (void *) element;
+
+	TRY
+	{
+		if (CF_List_GetSize (ctx) == 0)
 		{
-			node = traverser ? (CF_NODE *) traverser : context->rear;
-
-			newnode->prev = node;
-			if (node)
-			{
-				newnode->next = node->next;
-				node->next = newnode;
-				if (newnode->next)
-					newnode->next->prev = newnode;
-			}
-
-			if (node == context->rear)
-				context->rear = newnode;
+			context->front = context->rear = newnode;
+			TRY_BREAK;
 		}
+
+		node = traverser ? (CF_NODE *) traverser : context->rear;
+
+		newnode->prev = node;
+		if (node)
+		{
+			newnode->next = node->next;
+			node->next = newnode;
+			if (newnode->next)
+				newnode->next->prev = newnode;
+		}
+
+		if (node == context->rear)
+			context->rear = newnode;
 	} NO_CATCH;
 
@@ -209,4 +285,47 @@
 
 /**
+ * 리스트 탐색자(traverser)의 자리에 새 데이터 삽입
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param traverser	리스트 탐색자
+ * \param element	할당할 데이터 주소
+ */
+int
+CF_List_Set (const cf_traverser	traverser,
+			 const void			* element)
+{
+	CF_NODE * node = (CF_NODE *) traverser;
+
+	ASSERT_TRAVERSER (traverser);
+
+	node->element = (void *) element;
+
+	return CF_OK;
+}
+
+/**
+ * 탐색자 위치의 데이터를 가져옴
+ *
+ * \return 성공 시, CF_OK; 실패 시, 오류 코드
+ *
+ * \param traverser 리스트 탐색자
+ * \param element	데이터 주소
+ */
+int
+CF_List_Get (const cf_traverser	traverser,
+			 void				** element)
+{
+	CF_NODE * node = (CF_NODE *) traverser;
+
+	ASSERT_TRAVERSER (traverser);
+	ASSERT_ARGS (element == NULL);
+
+	*element = node->element;
+
+	return CF_OK;
+}
+
+/**
  * 리스트에서 탐색자 위치의 항목을 삭제
  *
@@ -217,6 +336,6 @@
  */
 int
-CF_List_Remove (CF_List_Ctx		ctx,
-				CF_Traverser	* traverser)
+CF_List_Remove (cf_ctx			ctx,
+				cf_traverser	* traverser)
 {
 	CF_LIST_CONTEXT	* context = (CF_LIST_CONTEXT *) ctx;
@@ -263,7 +382,7 @@
  */
 int
-CF_List_RemoveAll (CF_List_Ctx ctx)
-{
-	CF_Traverser traverser = NULL;
+CF_List_RemoveAll (cf_ctx ctx)
+{
+	cf_traverser traverser = NULL;
 
 	ASSERT_CTX (ctx);
@@ -279,26 +398,4 @@
 
 /**
- * 탐색자 위치의 데이터를 가져옴
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- *
- * \param traverser 리스트 탐색자
- * \param element	데이터 주소
- */
-int
-CF_List_GetElement (const CF_Traverser	traverser,
-					void				** element)
-{
-	CF_NODE * node = (CF_NODE *) traverser;
-
-	ASSERT_TRAVERSER (traverser);
-	ASSERT_ARGS (element == NULL);
-
-	*element = node->element;
-
-	return CF_OK;
-}
-
-/**
  * 탐색자 위치를 이전으로 이동
  *
@@ -308,5 +405,5 @@
  */
 int
-CF_List_Prev (CF_Traverser * traverser)
+CF_List_Prev (cf_traverser * traverser)
 {
 	CF_NODE * node = (CF_NODE *) *traverser;
@@ -316,5 +413,5 @@
 
 	node = node->prev;
-	*traverser = (CF_Traverser *) node;
+	*traverser = (cf_traverser *) node;
 	if (node == NULL)
 		return CF_ERROR_DS_NO_MORE;
@@ -331,5 +428,5 @@
  */
 int
-CF_List_Next (CF_Traverser * traverser)
+CF_List_Next (cf_traverser * traverser)
 {
 	CF_NODE * node = (CF_NODE *) *traverser;
@@ -339,5 +436,5 @@
 
 	node = node->next;
-	*traverser = (CF_Traverser *) node;
+	*traverser = (cf_traverser *) node;
 	if (node == NULL)
 		return CF_ERROR_DS_NO_MORE;
@@ -354,5 +451,5 @@
  */
 int
-CF_List_GetSize (CF_List_Ctx ctx)
+CF_List_GetSize (cf_ctx ctx)
 {
 	CF_LIST_CONTEXT * context = (CF_LIST_CONTEXT *) ctx;
Index: /trunk/src/cf_local.h
===================================================================
--- /trunk/src/cf_local.h	(revision 150)
+++ /trunk/src/cf_local.h	(revision 151)
@@ -6,4 +6,6 @@
 #ifndef __CF_LOCAL_H__
 #define __CF_LOCAL_H__
+
+#include <stdlib.h>
 
 /** 파일 이름 및 경로 길이 */
@@ -18,4 +20,12 @@
 #define CATCH_ELSE				else
 
+/**
+ * 유틸 매크로
+ *
+ * \remarks
+ * header는 별도로 include 해야 함
+ */
+#define NEWCTX(__ctx)			((__ctx *) calloc (sizeof (__ctx), 1))
+
 /** non-compatible function */
 #if defined(_WIN32) || defined(_WIN64)
Index: /trunk/src/cf_log.c
===================================================================
--- /trunk/src/cf_log.c	(revision 150)
+++ /trunk/src/cf_log.c	(revision 151)
@@ -19,4 +19,5 @@
 #include "cf_local.h"
 #include "cf_error.h"
+#include "cf_util.h"
 
 #include <stdio.h>
@@ -29,6 +30,7 @@
 # include <Windows.h>
 #else
-# include <sys/time.h>
 #endif
+
+#define LOG_BUFFER_DEFAULT_SIZE			128 * 1024
 
 #define ASSERT_CTX(__ctx)	\
@@ -36,153 +38,23 @@
 		return CF_ERROR_LOG_INVALID_CTX
 
-#define ASSERT_INIT()					\
-	if (gLogPool.ctxPool == NULL	||	\
-		gLogPool.poolSize <= 0		)	\
-		return CF_ERROR_LOG_NOT_INITIALIZE
-
-#define ASSERT_MAPID(__mapid)			\
-	if (gLogPool.poolSize <= __mapid)	\
-		return CF_ERROR_LOG_INVALID_MAPID
-
-#define ASSERT_MAPPED_CTX(__mapid)			\
-	if (gLogPool.ctxPool[__mapid] != NULL)	\
-		return CF_ERROR_LOG_ALREADY_MAPPED_ID
-
-#define ASSERT_NOT_MAPPED_CTX(__mapid)		\
-	if (gLogPool.ctxPool[__mapid] == NULL)	\
-		return CF_ERROR_LOG_NOT_MAPPED_ID
-
-#define LOG_BUFFER_DEFAULT_SIZE			128 * 1024
-
-#define LOG_DATETIME_LENGTH				sizeof ("0000-00-00 00:00:00.000") - 1
-
-/** 로그 컨텍스트 (Opaque) */
-typedef void *	CF_Log_Ctx;
-
-typedef struct __cf_util_datetime__
-{
-	int year;
-	int month;
-	int day;
-	int week; /* SUN:0 ~ SAT:6 */
-
-	int hour;
-	int min;
-	int sec;
-	int usec;
-} CF_LOG_DATETIME;
-
-/** 로그 컨텍스트 (CF_Log_Ctx의 구현) */
+#define ASSERT_ARGS(x)	\
+	if ((x))			\
+		return CF_ERROR_LOG_INVALID_ARGS
+
+/** 로그 컨텍스트 (cf_ctx의 구현) */
 typedef struct __cf_log_ctx__
 {
 	char			path[NAME_LENGTH + 1];
-	int				fd;
+	cf_ctx			file;
 	char			* buffer;
 	size_t			size;	/* entire size of buffer */
 	size_t			length; /* data length in current */
-	CF_Mutex_Ctx	mutex;
+	cf_ctx	mutex;
 } CF_LOG_CONTEXT;
-
-typedef struct __cf_log_array__
-{
-	CF_Log_Ctx	* ctxPool;
-	int			poolSize;
-} CF_LOG_POOL;
-
-static CF_LOG_POOL	gLogPool;
-
-#if defined(_WIN32) || defined(_WIN64)
-/* {{{ */
-struct timezone
-{
-	int tz_minuteswest;	/* minutes W of Greenwich */
-	int tz_dsttime;		/* type of dst correction */
-};
-
-int gettimeofday (struct timeval *tv, struct timezone *tz)
-{
-	FILETIME			ft;
-	unsigned __int64	buf =0;
-	//static int tzflag = 0;
-
-	if (NULL != tv)
-	{
-		GetSystemTimeAsFileTime (&ft);
-
-		buf |=	ft.dwHighDateTime;
-		buf <<=	32;
-		buf |=	ft.dwLowDateTime;
-
-		if (buf)
-		{
-			buf /= 10;
-			buf -= ((369 * 365 + 89) * (unsigned __int64) 86400) * 1000000;
-		}
-
-		tv->tv_sec = (long)(buf / 1000000UL);
-		tv->tv_usec = (long)(buf % 1000000UL);
-	}
-
-	/*
-	if (NULL != tz)
-	{
-		if (!tzflag)
-		{
-			_tzset();
-			tzflag++;
-		}
-
-		// Adjust for the timezone west of Greenwich
-		tz->tz_minuteswest = _timezone / 60;
-		tz->tz_dsttime = _daylight;
-	}
-	*/
-
-	return 0;
-}
-/* }}} */
-#endif
-
-static int
-CF_Log_Local_GetTime (CF_LOG_DATETIME * dt)
-{
-	struct timeval	timeVal;
-	struct tm		* timeSt;
-
-	gettimeofday (&timeVal, NULL);
-	timeSt = localtime ((const time_t *)&timeVal.tv_sec);
-
-	dt->year	= timeSt->tm_year + 1900;
-	dt->month	= timeSt->tm_mon + 1;
-	dt->day		= timeSt->tm_mday;
-	dt->week	= timeSt->tm_wday;
-
-	dt->hour	= timeSt->tm_hour;
-	dt->min		= timeSt->tm_min;
-	dt->sec		= timeSt->tm_sec;
-
-	dt->usec	= (int) timeVal.tv_usec;
-
-	return CF_OK;
-}
-
-static int
-CF_Log_Local_GetTimeString (char * buffer)
-{
-	CF_LOG_DATETIME dt;
-	CF_Log_Local_GetTime (&dt);
-
-	snprintf (buffer, LOG_DATETIME_LENGTH,
-			  "%04d-%02d-%02d %02d:%02d:%02d.%03d",
-			  dt.year, dt.month, dt.day,
-			  dt.hour, dt.min, dt.sec, dt.usec);
-
-	return CF_OK;
-}
 
 static int
 CF_Log_Local_Flush (CF_LOG_CONTEXT * ctx)
 {
-	if (CF_File_Write (ctx->fd, ctx->buffer, ctx->length) < 0)
+	if (CF_File_Write (ctx->file, ctx->buffer, ctx->length) < 0)
 		return CF_ERROR_LOG_FLUSH;
 
@@ -208,17 +80,21 @@
 				   const size_t		demandSize)
 {
-	int result = CF_OK;
+	int result = 0;
+
+	size_t writeSize;
+	size_t remainSize;
 
 	if (ctx->size > 0) /* 버퍼단위 버퍼링.... */
 	{
-		size_t writeSize;
-		size_t remainSize;
-
 		remainSize = demandSize;
 		while (remainSize)
 		{
-			writeSize = (ctx->size - ctx->length) < remainSize ? (ctx->size - ctx->length) : remainSize;
-
-			memcpy (ctx->buffer + ctx->length, buffer + demandSize - remainSize, writeSize);
+			writeSize = (ctx->size - ctx->length) < remainSize
+					  ? (ctx->size - ctx->length)
+					  : remainSize;
+
+			memcpy (ctx->buffer + ctx->length,
+					buffer + demandSize - remainSize,
+					writeSize);
 			ctx->length += writeSize;
 
@@ -247,12 +123,12 @@
  * \param ctx 로그 컨텍스트
  */
-static int
-CF_Log_SetMultiThread (CF_Log_Ctx ctx)
-{
-	CF_LOG_CONTEXT * context = (CF_LOG_CONTEXT *) ctx;
-
-	ASSERT_CTX (ctx);
-
-	if (CF_Mutex_CreateCtx (&context->mutex) < 0)
+int
+CF_Log_SetMultiThread (cf_ctx ctx)
+{
+	CF_LOG_CONTEXT * context = (CF_LOG_CONTEXT *) ctx;
+
+	ASSERT_CTX (ctx);
+
+	if (CF_Mutex_Create (&context->mutex) < 0)
 		return CF_ERROR_LOG_SET_MULTITHREAD;
 
@@ -267,12 +143,12 @@
  * \param ctx 로그 컨텍스트
  */
-static int
-CF_Log_UnsetMultiThread (CF_Log_Ctx ctx)
-{
-	CF_LOG_CONTEXT * context = (CF_LOG_CONTEXT *) ctx;
-
-	ASSERT_CTX (ctx);
-
-	if (CF_Mutex_DestoryCtx (context->mutex) < 0)
+int
+CF_Log_UnsetMultiThread (cf_ctx ctx)
+{
+	CF_LOG_CONTEXT * context = (CF_LOG_CONTEXT *) ctx;
+
+	ASSERT_CTX (ctx);
+
+	if (CF_Mutex_Destory (context->mutex) < 0)
 		return CF_ERROR_LOG_UNSET_MULTITHREAD;
 
@@ -293,19 +169,21 @@
  */
 static int
-CF_Log_Local_WriteVA (CF_Log_Ctx	ctx,
-					  const char	* prefix,
-					  const char	* fmt,
-					  va_list		valist)
+CF_Log_Local_WriteVA (CF_LOG_CONTEXT	* context,
+					  const char		* prefix,
+					  const char		* fmt,
+					  va_list			valist)
 {
 #define BUF_LEN	16 * 1024
-	CF_LOG_CONTEXT	* context = (CF_LOG_CONTEXT *) ctx;
-	char		buffer[BUF_LEN + 1] = {0x00,};
-	char		datetime[LOG_DATETIME_LENGTH + 1] = {0x00,};
-	int			length = 0;
-	int			result = 0;
-
-	ASSERT_CTX (ctx);
-
-	CF_Log_Local_GetTimeString (datetime);
+	char	buffer[BUF_LEN + 1] = {0x00,};
+	char	datetime[CF_UTIL_DATETIME_LENGTH + 1] = {0x00,};
+	int		length = 0;
+	int		result = 0;
+
+	CF_UTIL_DATETIME dt;
+
+	ASSERT_CTX (context);
+
+	CF_Util_GetCurrentTime (&dt);
+	CF_Util_GetTimeString (&dt, datetime);
 	length = snprintf (buffer, BUF_LEN, "[%s][%s] ", datetime, prefix);
 	vsnprintf (&buffer[length], BUF_LEN - (size_t)length, fmt, valist);
@@ -329,13 +207,15 @@
  */
 int
-CF_Log_WriteCtx (CF_Log_Ctx	ctx,
-				 const char	* prefix,
-				 const char	* fmt, ...)
-{
+CF_Log_Write (cf_ctx		ctx,
+			  const char	* prefix,
+			  const char	* fmt, ...)
+{
+	CF_LOG_CONTEXT * context = (CF_LOG_CONTEXT *) ctx;
+
 	int		result = 0;
 	va_list	valist;
 
 	va_start (valist, fmt);
-	result = CF_Log_Local_WriteVA (ctx, prefix, fmt, valist);
+	result = CF_Log_Local_WriteVA (context, prefix, fmt, valist);
 	va_end (valist);
 
@@ -350,9 +230,10 @@
  * \param ctx 로그 컨텍스트
  */
-static int
-CF_Log_FlushCtx (CF_Log_Ctx ctx)
-{
-	CF_LOG_CONTEXT	* context = (CF_LOG_CONTEXT *) ctx;
-	int			result = 0;
+int
+CF_Log_Flush (cf_ctx ctx)
+{
+	int result = 0;
+
+	CF_LOG_CONTEXT * context = (CF_LOG_CONTEXT *) ctx;
 
 	ASSERT_CTX (ctx);
@@ -372,6 +253,6 @@
  * \param ctx 로그 컨텍스트
  */
-static int
-CF_Log_DestroyCtx (CF_Log_Ctx ctx)
+int
+CF_Log_Destroy (cf_ctx ctx)
 {
 	CF_LOG_CONTEXT * context = (CF_LOG_CONTEXT *) ctx;
@@ -381,5 +262,5 @@
 	if (context->size > 0)
 	{
-		CF_Log_FlushCtx (ctx);
+		CF_Log_Flush (ctx);
 		free (context->buffer);
 		context->buffer = NULL;
@@ -387,8 +268,10 @@
 	}
 
-	CF_File_Close (context->fd);
-
-	CF_Mutex_DestoryCtx (context->mutex);
+	CF_File_Close (context->file);
+
+	CF_Mutex_Destory (context->mutex);
 	context->mutex = NULL;
+
+	free (context);
 
 	return CF_OK;
@@ -406,8 +289,8 @@
  * \see CF_LOG_DEFAULT_BUFFER, CF_LOG_NO_BUFFER
  */
-static int
-CF_Log_CreateCtx (CF_Log_Ctx	* ctx,
-				  const char	* path,
-				  const int		memsize)
+int
+CF_Log_Create (cf_ctx		* ctx,
+			   const char	* path,
+			   const int	memsize)
 {
 	int result = 0;
@@ -417,12 +300,12 @@
 			 : memsize;
 
-	CF_LOG_CONTEXT	* context = NULL;
-
-	if (path == NULL)
-		return CF_ERROR_LOG_INVALID_ARGS;
+	CF_LOG_CONTEXT * context = NULL;
+
+	ASSERT_CTX (ctx);
+	ASSERT_ARGS (path == NULL);
 
 	TRY
 	{
-		context = (CF_LOG_CONTEXT *) calloc (sizeof (CF_LOG_CONTEXT), 1);
+		context = NEWCTX (CF_LOG_CONTEXT);
 		if (context == NULL)
 		{
@@ -431,11 +314,11 @@
 		}
 
-		context->fd = CF_File_Open (path, fileFlag);
-		if (context->fd < 0)
+		result = CF_File_Open (&context->file, path, fileFlag);
+		if (result < 0)
 		{
 			result = CF_ERROR_LOG_CREATE_FILE;
 			TRY_BREAK;
 		}
-		snprintf (context->path, sizeof (context->path) -1, "%s", path);
+		snprintf (context->path, sizeof (context->path) - 1, "%s", path);
 
 		if (size > 0)
@@ -450,249 +333,11 @@
 		}
 
-		*ctx = (CF_Log_Ctx) context;
+		*ctx = (cf_ctx) context;
 	}
 	CATCH_IF (result < 0)
 	{
-		CF_Log_DestroyCtx ((CF_Log_Ctx) context);
-	}
-
-	return result;
-}
-
-/**
- * 로그 컨텍스트에 아이디 넘버 할당<br />
- * 로그 기록 시, 아이디 넘버를 사용하면 해당 로그로 기록할 수 있음
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- *
- * \param mapid	부여할 아이디 넘버
- * \param ctx	로그 컨텍스트
- *
- * \remarks 반드시 먼저 초기화 해야하며, 초기화 시에 주어진 번호보다 작은 아이디 넘버를 사용
- */
-static int
-CF_Log_MapCtxID (const int			mapid,
-				 const CF_Log_Ctx	ctx)
-{
-	ASSERT_INIT ();
-	ASSERT_MAPID (mapid);
-	ASSERT_MAPPED_CTX (mapid);
-
-	gLogPool.ctxPool[mapid] = ctx;
-
-	return CF_OK;
-}
-
-/**
- * 아이디 넘버에 해당하는 로그를 닫고 해당하는 컨텍스트를 해제
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- *
- * \param mapid 로그의 아이디 넘버
- *
- * \remarks 아이디 넘버에 해당하는 컨텍스트가 해제되므로 주의
- */
-static int
-CF_Log_UnmapCtxID (const int mapid)
-{
-	ASSERT_INIT ();
-	ASSERT_MAPID (mapid);
-	ASSERT_NOT_MAPPED_CTX (mapid);
-
-	CF_Log_DestroyCtx (gLogPool.ctxPool[mapid]);
-
-	free (gLogPool.ctxPool[mapid]);
-	gLogPool.ctxPool[mapid] = NULL;
-
-	return CF_OK;
-}
-
-/**
- * 아이디 넘버에 해당하는 로그 컨텍스트를 얻기
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- *
- * \param mapid	로그의 아이디 넘버
- * \param ctx	로그 컨텍스트 받을 주소
- */
-static int
-CF_Log_GetMappedCtx (const int	mapid,
-					 CF_Log_Ctx	* ctx)
-{
-	ASSERT_INIT ();
-	ASSERT_MAPID (mapid);
-	ASSERT_NOT_MAPPED_CTX (mapid);
-
-	*ctx = gLogPool.ctxPool[mapid];
-
-	return CF_OK;
-}
-
-/**
- * 로그를 사용하기 위해 초기화
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- *
- * \param poolSize	로그 풀 크기로, 로그 아이디 넘버의 최대 값
- */
-int
-CF_Log_Initialize (const int poolSize)
-{
-	memset (&gLogPool, 0x00, sizeof (CF_LOG_POOL));
-
-	if (poolSize > 0)
-	{
-		gLogPool.ctxPool =
-			(CF_Log_Ctx *) calloc ((size_t) poolSize, sizeof (CF_Log_Ctx));
-		if (gLogPool.ctxPool == NULL)
-			return CF_ERROR_LOG_INITIALIZE;
-		gLogPool.poolSize = poolSize;
-	}
-
-	return CF_OK;
-}
-
-/**
- * 로그가 모두 사용된 후 자원 해제
- *
- * \return CF_OK 반환
- */
-int
-CF_Log_Finalize (void)
-{
-	int mapid = 0;
-
-	for (mapid = 0 ; mapid < gLogPool.poolSize ; mapid++)
-	{
-		CF_Log_UnmapCtxID (mapid);
-	}
-
-	if (gLogPool.ctxPool != NULL)
-		free (gLogPool.ctxPool);
-
-	memset (&gLogPool, 0x00, sizeof (CF_LOG_POOL));
-
-	return CF_OK;
-}
-
-/**
- * 로그 열기
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- *
- * \param mapid		로그의 아이디 넘버
- * \param path		로그 파일 경로
- * \param memsize	로그 버퍼 크기
- *
- * \see CF_LOG_DEFAULT_BUFFER, CF_LOG_NO_BUFFER
- */
-int
-CF_Log_Open (const int	mapid,
-			 const char	* path,
-			 const int	memsize)
-{
-	int			result = 0;
-	CF_Log_Ctx	ctx = NULL;
-
-	result = CF_Log_CreateCtx (&ctx, path, memsize);
-	if (result < 0)
-		return result;
-
-	result = CF_Log_MapCtxID (mapid, ctx);
-	if (result < 0)
-		CF_Log_DestroyCtx (ctx);
-
-	return result;
-}
-
-/**
- * 로그 닫기
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- *
- * \param mapid 로그의 아이디 넘버
- */
-int
-CF_Log_Close (const int mapid)
-{
-	return CF_Log_UnmapCtxID (mapid);
-}
-
-/**
- * 로그 버퍼의 데이터를 즉시 로그 파일에 쓰기
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- *
- * \param mapid 로그의 아이디 넘버
- */
-int
-CF_Log_Flush (const int mapid)
-{
-	int			result = 0;
-	CF_Log_Ctx	ctx = NULL;
-
-	result = CF_Log_GetMappedCtx (mapid, &ctx);
-	if (result < 0)
-		return result;
-
-	result = CF_Log_FlushCtx (ctx);
-
-	return result;
-}
-
-/**
- * 로그 컨텍스트에 멀티쓰레드 모드 설정
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드 
- *
- * \param mapid	로그의 아이디 넘버
- * \param flag	설정/해제 bool 플래그
- *
- * \see CF_BOOL
- */
-int
-CF_Log_SetMT (const int		mapid,
-			  const CF_BOOL	flag)
-{
-	int			result = 0;
-	CF_Log_Ctx	ctx = NULL;
-
-	result = CF_Log_GetMappedCtx (mapid, &ctx);
-	if (result < 0)
-		return result;
-
-	result = (flag) ? CF_Log_SetMultiThread (ctx) :
-					  CF_Log_UnsetMultiThread (ctx);
-
-	return result;
-}
-
-/**
- * 로그 쓰기
- *
- * \return 성공 시, CF_OK; 실패 시, 오류 코드
- *
- * \param mapid		로그의 아이디 넘버
- * \param prefix	로그의 프리픽스 문자열
- * \param fmt		포맷 스트링
- * \param ...		가변 인자
- */
-int
-CF_Log_Write (const int		mapid,
-			  const char	* prefix,
-			  const char	* fmt, ...)
-{
-	int			result = 0;
-	CF_Log_Ctx	ctx = NULL;
-	va_list		valist;
-
-	result = CF_Log_GetMappedCtx (mapid, &ctx);
-	if (result < 0)
-		return result;
-
-	va_start (valist, fmt);
-	result = CF_Log_Local_WriteVA (ctx, prefix, fmt, valist);
-	va_end (valist);
-
-	return result;
-}
+		CF_Log_Destroy ((cf_ctx) context);
+	}
+
+	return result;
+}
